Index: uspace/srv/hid/console/console.c
===================================================================
--- uspace/srv/hid/console/console.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/srv/hid/console/console.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -54,9 +54,11 @@
 #include <vfs/vfs.h>
 #include <fibril_synch.h>
+#include <io/style.h>
+#include <io/screenbuffer.h>
 
 #include "console.h"
 #include "gcons.h"
 #include "keybuffer.h"
-#include "screenbuffer.h"
+
 
 #define NAME       "console"
@@ -71,8 +73,8 @@
 /** Information about framebuffer */
 struct {
-	int phone;      /**< Framebuffer phone */
-	ipcarg_t cols;  /**< Framebuffer columns */
-	ipcarg_t rows;  /**< Framebuffer rows */
-	int color_cap;  /**< Color capabilities (FB_CCAP_xxx) */
+	int phone;           /**< Framebuffer phone */
+	ipcarg_t cols;       /**< Framebuffer columns */
+	ipcarg_t rows;       /**< Framebuffer rows */
+	ipcarg_t color_cap;  /**< Color capabilities (FB_CCAP_xxx) */
 } fb_info;
 
@@ -99,7 +101,7 @@
 /** Information on row-span yet unsent to FB driver. */
 struct {
-	size_t col;  /**< Leftmost column of the span. */
-	size_t row;  /**< Row where the span lies. */
-	size_t cnt;  /**< Width of the span. */
+	ipcarg_t col;  /**< Leftmost column of the span. */
+	ipcarg_t row;  /**< Row where the span lies. */
+	ipcarg_t cnt;  /**< Width of the span. */
 } fb_pending;
 
@@ -117,5 +119,5 @@
 }
 
-static void curs_goto(size_t x, size_t y)
+static void curs_goto(ipcarg_t x, ipcarg_t y)
 {
 	async_msg_2(fb_info.phone, FB_CURSOR_GOTO, x, y);
@@ -147,15 +149,15 @@
 }
 
-static void set_style(int style)
+static void set_style(uint8_t style)
 {
 	async_msg_1(fb_info.phone, FB_SET_STYLE, style);
 }
 
-static void set_color(int fgcolor, int bgcolor, int flags)
+static void set_color(uint8_t fgcolor, uint8_t bgcolor, uint8_t flags)
 {
 	async_msg_3(fb_info.phone, FB_SET_COLOR, fgcolor, bgcolor, flags);
 }
 
-static void set_rgb_color(int fgcolor, int bgcolor)
+static void set_rgb_color(uint32_t fgcolor, uint32_t bgcolor)
 {
 	async_msg_2(fb_info.phone, FB_SET_RGB_COLOR, fgcolor, bgcolor); 
@@ -178,14 +180,23 @@
 }
 
-static int ccap_fb_to_con(int ccap_fb, int *ccap_con)
+static int ccap_fb_to_con(ipcarg_t ccap_fb, ipcarg_t *ccap_con)
 {
 	switch (ccap_fb) {
-	case FB_CCAP_NONE: *ccap_con = CONSOLE_CCAP_NONE; break;
-	case FB_CCAP_STYLE: *ccap_con = CONSOLE_CCAP_STYLE; break;
-	case FB_CCAP_INDEXED: *ccap_con = CONSOLE_CCAP_INDEXED; break;
-	case FB_CCAP_RGB: *ccap_con = CONSOLE_CCAP_RGB; break;
-	default: return EINVAL;
-	}
-
+	case FB_CCAP_NONE:
+		*ccap_con = CONSOLE_CCAP_NONE;
+		break;
+	case FB_CCAP_STYLE:
+		*ccap_con = CONSOLE_CCAP_STYLE;
+		break;
+	case FB_CCAP_INDEXED:
+		*ccap_con = CONSOLE_CCAP_INDEXED;
+		break;
+	case FB_CCAP_RGB:
+		*ccap_con = CONSOLE_CCAP_RGB;
+		break;
+	default:
+		return EINVAL;
+	}
+	
 	return EOK;
 }
@@ -226,5 +237,5 @@
  *
  */
-static void cell_mark_changed(size_t col, size_t row)
+static void cell_mark_changed(ipcarg_t col, ipcarg_t row)
 {
 	if (fb_pending.cnt != 0) {
@@ -253,5 +264,5 @@
 {
 	bool flush_cursor = false;
-
+	
 	switch (ch) {
 	case '\n':
@@ -297,5 +308,5 @@
 			async_msg_1(fb_info.phone, FB_SCROLL, 1);
 	}
-
+	
 	if (cons == active_console && flush_cursor)
 		curs_goto(cons->scr.position_x, cons->scr.position_y);
@@ -327,8 +338,4 @@
 	
 	if (cons != kernel_console) {
-		size_t x;
-		size_t y;
-		int rc = 0;
-		
 		async_serialize_start();
 		
@@ -344,4 +351,9 @@
 		set_attrs(&cons->scr.attrs);
 		curs_visibility(false);
+		
+		ipcarg_t x;
+		ipcarg_t y;
+		int rc = 0;
+		
 		if (interbuffer) {
 			for (y = 0; y < cons->scr.size_y; y++) {
@@ -390,5 +402,4 @@
 	/* Ignore parameters, the connection is already opened */
 	while (true) {
-		
 		ipc_call_t call;
 		ipc_callid_t callid = async_get_call(&call);
@@ -433,16 +444,11 @@
 static void mouse_events(ipc_callid_t iid, ipc_call_t *icall)
 {
-	int button, press;
-	int dx, dy;
-	int newcon;
-
 	/* Ignore parameters, the connection is already opened */
 	while (true) {
-
 		ipc_call_t call;
 		ipc_callid_t callid = async_get_call(&call);
-
+		
 		int retval;
-
+		
 		switch (IPC_GET_METHOD(call)) {
 		case IPC_M_PHONE_HUNGUP:
@@ -450,8 +456,6 @@
 			return;
 		case MEVENT_BUTTON:
-			button = IPC_GET_ARG1(call);
-			press = IPC_GET_ARG2(call);
-			if (button == 1) {
-				newcon = gcons_mouse_btn(press);
+			if (IPC_GET_ARG1(call) == 1) {
+				int newcon = gcons_mouse_btn((bool) IPC_GET_ARG2(call));
 				if (newcon != -1)
 					change_console(&consoles[newcon]);
@@ -460,7 +464,6 @@
 			break;
 		case MEVENT_MOVE:
-			dx = IPC_GET_ARG1(call);
-			dy = IPC_GET_ARG2(call);
-			gcons_mouse_move(dx, dy);
+			gcons_mouse_move((int) IPC_GET_ARG1(call),
+			    (int) IPC_GET_ARG2(call));
 			retval = 0;
 			break;
@@ -520,4 +523,5 @@
 	console_event_t ev;
 	fibril_mutex_lock(&input_mutex);
+	
 recheck:
 	while ((keybuffer_pop(&cons->keybuffer, &ev)) && (pos < size)) {
@@ -536,4 +540,5 @@
 		goto recheck;
 	}
+	
 	fibril_mutex_unlock(&input_mutex);
 }
@@ -542,6 +547,7 @@
 {
 	console_event_t ev;
-
+	
 	fibril_mutex_lock(&input_mutex);
+	
 recheck:
 	if (keybuffer_pop(&cons->keybuffer, &ev)) {
@@ -551,4 +557,5 @@
 		goto recheck;
 	}
+	
 	fibril_mutex_unlock(&input_mutex);
 }
@@ -580,6 +587,5 @@
 	ipcarg_t arg2;
 	ipcarg_t arg3;
-
-	int cons_ccap;
+	
 	int rc;
 	
@@ -622,5 +628,4 @@
 			if (cons == active_console) {
 				async_req_0_0(fb_info.phone, FB_FLUSH);
-				
 				curs_goto(cons->scr.position_x, cons->scr.position_y);
 			}
@@ -650,10 +655,9 @@
 			break;
 		case CONSOLE_GET_COLOR_CAP:
-			rc = ccap_fb_to_con(fb_info.color_cap, &cons_ccap);
+			rc = ccap_fb_to_con(fb_info.color_cap, &arg1);
 			if (rc != EOK) {
 				ipc_answer_0(callid, rc);
 				continue;
 			}
-			arg1 = cons_ccap;
 			break;
 		case CONSOLE_SET_STYLE:
@@ -714,5 +718,5 @@
 		return false;
 	}
-
+	
 	kbd_phone = fd_phone(input_fd);
 	if (kbd_phone < 0) {
@@ -720,5 +724,5 @@
 		return false;
 	}
-
+	
 	/* NB: The callback connection is slotted for removal */
 	ipcarg_t phonehash;
@@ -727,16 +731,16 @@
 		return false;
 	}
-
+	
 	async_new_connection(phonehash, 0, NULL, keyboard_events);
-
+	
 	/* Connect to mouse device */
 	mouse_phone = -1;
 	int mouse_fd = open("/dev/hid_in/mouse", O_RDONLY);
-
+	
 	if (mouse_fd < 0) {
 		printf(NAME ": Notice - failed opening %s\n", "/dev/hid_in/mouse");
 		goto skip_mouse;
 	}
-
+	
 	mouse_phone = fd_phone(mouse_fd);
 	if (mouse_phone < 0) {
@@ -744,5 +748,5 @@
 		goto skip_mouse;
 	}
-
+	
 	if (ipc_connect_to_me(mouse_phone, SERVICE_CONSOLE, 0, 0, &phonehash) != 0) {
 		printf(NAME ": Failed to create callback from mouse device\n");
@@ -750,8 +754,8 @@
 		goto skip_mouse;
 	}
-
+	
 	async_new_connection(phonehash, 0, NULL, mouse_events);
 skip_mouse:
-
+	
 	/* Connect to framebuffer driver */
 	fb_info.phone = ipc_connect_me_to_blocking(PHONE_NS, SERVICE_VIDEO, 0, 0);
@@ -760,5 +764,5 @@
 		return -1;
 	}
-
+	
 	/* Register driver */
 	int rc = devmap_driver_register(NAME, client_connection);
@@ -772,9 +776,7 @@
 	
 	/* Synchronize, the gcons could put something in queue */
-	ipcarg_t color_cap;
 	async_req_0_0(fb_info.phone, FB_FLUSH);
 	async_req_0_2(fb_info.phone, FB_GET_CSIZE, &fb_info.cols, &fb_info.rows);
-	async_req_0_1(fb_info.phone, FB_GET_COLOR_CAP, &color_cap);
-	fb_info.color_cap = color_cap;
+	async_req_0_1(fb_info.phone, FB_GET_COLOR_CAP, &fb_info.color_cap);
 	
 	/* Set up shared memory buffer. */
@@ -827,5 +829,5 @@
 	async_serialize_start();
 	gcons_redraw_console();
-	set_rgb_color(DEFAULT_FOREGROUND, DEFAULT_BACKGROUND);
+	set_style(STYLE_NORMAL);
 	screen_clear();
 	curs_goto(0, 0);
Index: uspace/srv/hid/console/gcons.c
===================================================================
--- uspace/srv/hid/console/gcons.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/srv/hid/console/gcons.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -54,5 +54,30 @@
 #define STATUS_HEIGHT  48
 
-#define MAIN_COLOR  0xffffff
+#define COLOR_MAIN        0xffffff
+#define COLOR_FOREGROUND  0x202020
+#define COLOR_BACKGROUND  0xffffff
+
+extern char _binary_gfx_helenos_ppm_start[0];
+extern int _binary_gfx_helenos_ppm_size;
+extern char _binary_gfx_nameic_ppm_start[0];
+extern int _binary_gfx_nameic_ppm_size;
+
+extern char _binary_gfx_anim_1_ppm_start[0];
+extern int _binary_gfx_anim_1_ppm_size;
+extern char _binary_gfx_anim_2_ppm_start[0];
+extern int _binary_gfx_anim_2_ppm_size;
+extern char _binary_gfx_anim_3_ppm_start[0];
+extern int _binary_gfx_anim_3_ppm_size;
+extern char _binary_gfx_anim_4_ppm_start[0];
+extern int _binary_gfx_anim_4_ppm_size;
+
+extern char _binary_gfx_cons_selected_ppm_start[0];
+extern int _binary_gfx_cons_selected_ppm_size;
+extern char _binary_gfx_cons_idle_ppm_start[0];
+extern int _binary_gfx_cons_idle_ppm_size;
+extern char _binary_gfx_cons_has_data_ppm_start[0];
+extern int _binary_gfx_cons_has_data_ppm_size;
+extern char _binary_gfx_cons_kernel_ppm_start[0];
+extern int _binary_gfx_cons_kernel_ppm_size;
 
 static bool use_gcons = false;
@@ -82,10 +107,10 @@
 static size_t active_console = 0;
 
-size_t mouse_x;
-size_t mouse_y;
-
-bool btn_pressed;
-size_t btn_x;
-size_t btn_y;
+static ipcarg_t mouse_x = 0;
+static ipcarg_t mouse_y= 0;
+
+static bool btn_pressed = false;
+static ipcarg_t btn_x = 0;
+static ipcarg_t btn_y = 0;
 
 static void vp_switch(int vp)
@@ -95,5 +120,5 @@
 
 /** Create view port */
-static int vp_create(size_t x, size_t y, size_t width, size_t height)
+static int vp_create(ipcarg_t x, ipcarg_t y, ipcarg_t width, ipcarg_t height)
 {
 	return async_req_2_0(fbphone, FB_VIEWPORT_CREATE, (x << 16) | y,
@@ -112,5 +137,5 @@
 
 /** Transparent putchar */
-static void tran_putch(wchar_t ch, size_t col, size_t row)
+static void tran_putch(wchar_t ch, ipcarg_t col, ipcarg_t row)
 {
 	async_msg_3(fbphone, FB_PUTCHAR, ch, col, row);
@@ -259,14 +284,17 @@
 void gcons_mouse_move(ssize_t dx, ssize_t dy)
 {
-	mouse_x = limit(mouse_x + dx, 0, xres);
-	mouse_y = limit(mouse_y + dy, 0, yres);
-
+	ssize_t nx = (ssize_t) mouse_x + dx;
+	ssize_t ny = (ssize_t) mouse_y + dy;
+	
+	mouse_x = (size_t) limit(nx, 0, xres);
+	mouse_y = (size_t) limit(ny, 0, yres);
+	
 	if (active_console != KERNEL_CONSOLE)
 		async_msg_2(fbphone, FB_POINTER_MOVE, mouse_x, mouse_y);
 }
 
-static int gcons_find_conbut(int x, int y)
-{
-	int status_start = STATUS_START + (xres - 800) / 2;
+static int gcons_find_conbut(ipcarg_t x, ipcarg_t y)
+{
+	ipcarg_t status_start = STATUS_START + (xres - 800) / 2;
 	
 	if ((y < STATUS_TOP) || (y >= STATUS_TOP + STATUS_HEIGHT))
@@ -278,8 +306,14 @@
 	if (x >= status_start + (STATUS_WIDTH + STATUS_SPACE) * CONSOLE_COUNT)
 		return -1;
+	
 	if (((x - status_start) % (STATUS_WIDTH + STATUS_SPACE)) < STATUS_SPACE)
 		return -1;
 	
-	return (x - status_start) / (STATUS_WIDTH + STATUS_SPACE);
+	ipcarg_t btn = (x - status_start) / (STATUS_WIDTH + STATUS_SPACE);
+	
+	if (btn < CONSOLE_COUNT)
+		return btn;
+	
+	return -1;
 }
 
@@ -287,11 +321,15 @@
  *
  * @param state New state (true - pressed, false - depressed)
+ *
  */
 int gcons_mouse_btn(bool state)
 {
-	int conbut;
+	/* Ignore mouse clicks if no buttons
+	   are drawn at all */
+	if (xres < 800)
+		return -1;
 	
 	if (state) {
-		conbut = gcons_find_conbut(mouse_x, mouse_y);
+		int conbut = gcons_find_conbut(mouse_x, mouse_y);
 		if (conbut != -1) {
 			btn_pressed = true;
@@ -307,5 +345,5 @@
 	btn_pressed = false;
 	
-	conbut = gcons_find_conbut(mouse_x, mouse_y);
+	int conbut = gcons_find_conbut(mouse_x, mouse_y);
 	if (conbut == gcons_find_conbut(btn_x, btn_y))
 		return conbut;
@@ -313,5 +351,4 @@
 	return -1;
 }
-
 
 /** Draw a PPM pixmap to framebuffer
@@ -321,12 +358,10 @@
  * @param x Coordinate of upper left corner
  * @param y Coordinate of upper left corner
- */
-static void draw_pixmap(char *logo, size_t size, int x, int y)
-{
-	char *shm;
-	int rc;
-	
+ *
+ */
+static void draw_pixmap(char *logo, size_t size, ipcarg_t x, ipcarg_t y)
+{
 	/* Create area */
-	shm = mmap(NULL, size, PROTO_READ | PROTO_WRITE, MAP_SHARED |
+	char *shm = mmap(NULL, size, PROTO_READ | PROTO_WRITE, MAP_SHARED |
 	    MAP_ANONYMOUS, 0, 0);
 	if (shm == MAP_FAILED)
@@ -336,5 +371,5 @@
 	
 	/* Send area */
-	rc = async_req_1_0(fbphone, FB_PREPARE_SHM, (ipcarg_t) shm);
+	int rc = async_req_1_0(fbphone, FB_PREPARE_SHM, (ipcarg_t) shm);
 	if (rc)
 		goto exit;
@@ -356,19 +391,12 @@
 }
 
-extern char _binary_gfx_helenos_ppm_start[0];
-extern int _binary_gfx_helenos_ppm_size;
-extern char _binary_gfx_nameic_ppm_start[0];
-extern int _binary_gfx_nameic_ppm_size;
-
 /** Redraws console graphics */
 void gcons_redraw_console(void)
 {
-	int i;
-	
 	if (!use_gcons)
 		return;
 	
 	vp_switch(0);
-	set_rgb_color(MAIN_COLOR, MAIN_COLOR);
+	set_rgb_color(COLOR_MAIN, COLOR_MAIN);
 	clear();
 	draw_pixmap(_binary_gfx_helenos_ppm_start,
@@ -377,4 +405,5 @@
 	    (size_t) &_binary_gfx_nameic_ppm_size, 5, 17);
 	
+	unsigned int i;
 	for (i = 0; i < CONSOLE_COUNT; i++)
 		redraw_state(i);
@@ -393,10 +422,6 @@
 static int make_pixmap(char *data, size_t size)
 {
-	char *shm;
-	int rc;
-	int pxid = -1;
-	
 	/* Create area */
-	shm = mmap(NULL, size, PROTO_READ | PROTO_WRITE, MAP_SHARED |
+	char *shm = mmap(NULL, size, PROTO_READ | PROTO_WRITE, MAP_SHARED |
 	    MAP_ANONYMOUS, 0, 0);
 	if (shm == MAP_FAILED)
@@ -405,6 +430,8 @@
 	memcpy(shm, data, size);
 	
+	int pxid = -1;
+	
 	/* Send area */
-	rc = async_req_1_0(fbphone, FB_PREPARE_SHM, (ipcarg_t) shm);
+	int rc = async_req_1_0(fbphone, FB_PREPARE_SHM, (ipcarg_t) shm);
 	if (rc)
 		goto exit;
@@ -432,16 +459,8 @@
 }
 
-extern char _binary_gfx_anim_1_ppm_start[0];
-extern int _binary_gfx_anim_1_ppm_size;
-extern char _binary_gfx_anim_2_ppm_start[0];
-extern int _binary_gfx_anim_2_ppm_size;
-extern char _binary_gfx_anim_3_ppm_start[0];
-extern int _binary_gfx_anim_3_ppm_size;
-extern char _binary_gfx_anim_4_ppm_start[0];
-extern int _binary_gfx_anim_4_ppm_size;
-
 static void make_anim(void)
 {
-	int an = async_req_1_0(fbphone, FB_ANIM_CREATE, cstatus_vp[KERNEL_CONSOLE]);
+	int an = async_req_1_0(fbphone, FB_ANIM_CREATE,
+	    cstatus_vp[KERNEL_CONSOLE]);
 	if (an < 0)
 		return;
@@ -467,13 +486,4 @@
 	animation = an;
 }
-
-extern char _binary_gfx_cons_selected_ppm_start[0];
-extern int _binary_gfx_cons_selected_ppm_size;
-extern char _binary_gfx_cons_idle_ppm_start[0];
-extern int _binary_gfx_cons_idle_ppm_size;
-extern char _binary_gfx_cons_has_data_ppm_start[0];
-extern int _binary_gfx_cons_has_data_ppm_size;
-extern char _binary_gfx_cons_kernel_ppm_start[0];
-extern int _binary_gfx_cons_kernel_ppm_size;
 
 /** Initialize nice graphical console environment */
@@ -500,5 +510,5 @@
 	
 	/* Create status buttons */
-	size_t status_start = STATUS_START + (xres - 800) / 2;
+	ipcarg_t status_start = STATUS_START + (xres - 800) / 2;
 	size_t i;
 	for (i = 0; i < CONSOLE_COUNT; i++) {
@@ -511,5 +521,5 @@
 		
 		vp_switch(cstatus_vp[i]);
-		set_rgb_color(0x202020, 0xffffff);
+		set_rgb_color(COLOR_FOREGROUND, COLOR_BACKGROUND);
 	}
 	
Index: uspace/srv/hid/console/gcons.h
===================================================================
--- uspace/srv/hid/console/gcons.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/srv/hid/console/gcons.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -38,15 +38,15 @@
 #include <sys/types.h>
 
-void gcons_init(int phone);
+void gcons_init(int);
 
 void gcons_redraw_console(void);
-void gcons_change_console(size_t index);
-void gcons_notify_char(size_t index);
+void gcons_change_console(size_t);
+void gcons_notify_char(size_t);
 void gcons_in_kernel(void);
 
-void gcons_notify_connect(size_t index);
-void gcons_notify_disconnect(size_t index);
+void gcons_notify_connect(size_t);
+void gcons_notify_disconnect(size_t);
 
-void gcons_mouse_move(ssize_t dx, ssize_t dy);
+void gcons_mouse_move(ssize_t, ssize_t);
 int gcons_mouse_btn(bool state);
 
Index: uspace/srv/hid/console/keybuffer.h
===================================================================
--- uspace/srv/hid/console/keybuffer.h	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/srv/hid/console/keybuffer.h	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -47,7 +47,7 @@
 typedef struct {
 	console_event_t fifo[KEYBUFFER_SIZE];
-	unsigned long head;
-	unsigned long tail;
-	unsigned long items;
+	size_t head;
+	size_t tail;
+	size_t items;
 } keybuffer_t;
 
Index: uspace/srv/hid/fb/Makefile
===================================================================
--- uspace/srv/hid/fb/Makefile	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/srv/hid/fb/Makefile	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -29,5 +29,13 @@
 
 USPACE_PREFIX = ../../..
+ROOT_PATH = $(USPACE_PREFIX)/..
+
+COMMON_MAKEFILE = $(ROOT_PATH)/Makefile.common
+CONFIG_MAKEFILE = $(ROOT_PATH)/Makefile.config
+
 BINARY = fb
+
+-include $(COMMON_MAKEFILE)
+-include $(CONFIG_MAKEFILE)
 
 SOURCES = \
@@ -36,43 +44,50 @@
 
 ifneq ($(UARCH),ia64)
-	SOURCES += fb.c \
+	SOURCES += \
+		fb.c \
 		font-8x16.c
-	EXTRA_CFLAGS = -DFB_ENABLED
+	EXTRA_CFLAGS += -DFB_ENABLED
 endif
 
 ifeq ($(UARCH),ia32)
-	SOURCES += ega.c
-	EXTRA_CFLAGS = -DEGA_ENABLED
+	SOURCES += \
+		ega.c
+	EXTRA_CFLAGS += -DEGA_ENABLED
 endif
 
 ifeq ($(UARCH),ia64)
-	SOURCES += ega.c \
+	SOURCES += \
+		ega.c \
 		ski.c \
 		serial_console.c
-	EXTRA_CFLAGS = -DSKI_ENABLED -DEGA_ENABLED
+	EXTRA_CFLAGS += -DSKI_ENABLED -DEGA_ENABLED
 endif
 
 ifeq ($(UARCH),amd64)
-	SOURCES += ega.c
-	EXTRA_CFLAGS = -DEGA_ENABLED
+	SOURCES += \
+		ega.c
+	EXTRA_CFLAGS += -DEGA_ENABLED
 endif
 
 ifeq ($(UARCH),mips32)
-	SOURCES += msim.c \
+	SOURCES += \
+		msim.c \
 		serial_console.c
-	EXTRA_CFLAGS = -DMSIM_ENABLED
+	EXTRA_CFLAGS += -DMSIM_ENABLED
 endif
 
 ifeq ($(UARCH),sparc64)
-	ifeq ($(PROCESSOR), sun4v)
-		SOURCES += niagara.c \
+	ifeq ($(PROCESSOR),sun4v)
+		SOURCES += \
+			niagara.c \
 			serial_console.c
-		EXTRA_CFLAGS = -DNIAGARA_ENABLED
+		EXTRA_CFLAGS += -DNIAGARA_ENABLED
 	endif
-
-	ifeq ($(MACHINE), serengeti)
-		SOURCES += sgcn.c \
+	
+	ifeq ($(MACHINE),serengeti)
+		SOURCES += \
+			sgcn.c \
 			serial_console.c
-		EXTRA_CFLAGS = -DSGCN_ENABLED
+		EXTRA_CFLAGS += -DSGCN_ENABLED
 	endif
 endif
Index: uspace/srv/hid/fb/ega.c
===================================================================
--- uspace/srv/hid/fb/ega.c	(revision 38aaacc20a85af2361a0240ac2e7d643e086ecfa)
+++ uspace/srv/hid/fb/ega.c	(revision f4f866c362e11c16ac8b6212e491af00b0bed2f2)
@@ -28,8 +28,8 @@
 
 /** @defgroup egafb EGA framebuffer
- * @brief	HelenOS EGA framebuffer.
+ * @brief HelenOS EGA framebuffer.
  * @ingroup fbs
  * @{
- */ 
+ */
 /** @file
  */
@@ -52,11 +52,12 @@
 #include <io/style.h>
 #include <io/color.h>
+#include <io/screenbuffer.h>
 #include <sys/types.h>
 
 #include "ega.h"
-#include "../console/screenbuffer.h"
 #include "main.h"
 
-#define MAX_SAVED_SCREENS 256
+#define MAX_SAVED_SCREENS  256
+
 typedef struct saved_screen {
 	short *data;
@@ -65,24 +66,70 @@
 saved_screen saved_screens[MAX_SAVED_SCREENS];
 
-#define EGA_IO_BASE ((ioport8_t *) 0x3d4)
-#define EGA_IO_SIZE 2
-
-int ega_normal_color = 0x0f;
-int ega_inverted_color = 0xf0;
-
-#define NORMAL_COLOR		ega_normal_color
-#define INVERTED_COLOR		ega_inverted_color
+#define EGA_IO_BASE  ((ioport8_t *) 0x3d4)
+#define EGA_IO_SIZE  2
 
 /* Allow only 1 connection */
 static int client_connected = 0;
 
-static unsigned int scr_width;
-static unsigned int scr_height;
+static sysarg_t scr_width;
+static sysarg_t scr_height;
 static uint8_t *scr_addr;
 
-static unsigned int style;
-
-static unsigned attr_to_ega_style(const attrs_t *a);
-static uint8_t ega_glyph(wchar_t ch);
+static uint8_t style_normal = 0xf0;
+static uint8_t style_inverted = 0x0f;
+static uint8_t style;
+
+static uint8_t style_to_ega_style(uint8_t style)
+{
+	switch (style) {
+	case STYLE_EMPHASIS:
+		return (style_normal | 0x04);
+	case STYLE_SELECTED:
+		return (style_inverted | 0x40);
+	case STYLE_INVERTED:
+		return style_inverted;
+	}
+	
+	return style_normal;
+}
+
+static uint8_t color_to_ega_style(uint8_t fg_color, uint8_t bg_color,
+    uint8_t attr)
+{
+	uint8_t style = (fg_color & 7) | ((bg_color & 7) << 4);
+	
+	if (attr & CATTR_BRIGHT)
+		style |= 0x08;
+	
+	return style;
+}
+
+static uint8_t rgb_to_ega_style(uint32_t fg, uint32_t bg)
+{
+	return (fg > bg) ? style_inverted : style_normal;
+}
+
+static uint8_t attr_to_ega_style(const attrs_t *attr)
+{
+	switch (attr->t) {
+	case at_style:
+		return style_to_ega_style(attr->a.s.style);
+	case at_idx:
+		return color_to_ega_style(attr->a.i.fg_color,
+		    attr->a.i.bg_color, attr->a.i.flags);
+	case at_rgb:
+		return rgb_to_ega_style(attr->a.r.fg_color, attr->a.r.bg_color);
+	default:
+		return style_normal;
+	}
+}
+
+static uint8_t ega_glyph(wchar_t ch)
+{
+	if (ch >= 0 && ch < 128)
+		return ch;
+	
+	return '?';
+}
 
 static void clrscr(void)
@@ -96,22 +143,20 @@
 }
 
-static void cursor_goto(unsigned int col, unsigned int row)
-{
-	int ega_cursor;
-
-	ega_cursor = col + scr_width * row;
+static void cursor_goto(sysarg_t col, sysarg_t row)
+{
+	sysarg_t cursor = col + scr_width * row;
 	
 	pio_write_8(EGA_IO_BASE, 0xe);
-	pio_write_8(EGA_IO_BASE + 1, (ega_cursor >> 8) & 0xff);
+	pio_write_8(EGA_IO_BASE + 1, (cursor >> 8) & 0xff);
 	pio_write_8(EGA_IO_BASE, 0xf);
-	pio_write_8(EGA_IO_BASE + 1, ega_cursor & 0xff);
+	pio_write_8(EGA_IO_BASE + 1, cursor & 0xff);
 }
 
 static void cursor_disable(void)
 {
-	uint8_t stat;
-
 	pio_write_8(EGA_IO_BASE, 0xa);
-	stat = pio_read_8(EGA_IO_BASE + 1);
+	
+	uint8_t stat = pio_read_8(EGA_IO_BASE + 1);
+	
 	pio_write_8(EGA_IO_BASE, 0xa);
 	pio_write_8(EGA_IO_BASE + 1, stat | (1 << 5));
@@ -120,16 +165,16 @@
 static void cursor_enable(void)
 {
-	uint8_t stat;
-
 	pio_write_8(EGA_IO_BASE, 0xa);
-	stat = pio_read_8(EGA_IO_BASE + 1);
+	
+	uint8_t stat = pio_read_8(EGA_IO_BASE + 1);
+	
 	pio_write_8(EGA_IO_BASE, 0xa);
 	pio_write_8(EGA_IO_BASE + 1, stat & (~(1 << 5)));
 }
 
-static void scroll(int rows)
-{
-	unsigned i;
-
+static void scroll(ssize_t rows)
+{
+	size_t i;
+	
 	if (rows > 0) {
 		memmove(scr_addr, ((char *) scr_addr) + rows * scr_width * 2,
@@ -142,9 +187,9 @@
 		    scr_width * scr_height * 2 + rows * scr_width * 2);
 		for (i = 0; i < -rows * scr_width; i++)
-			((short *)scr_addr)[i] = ((style << 8 ) + ' ');
-	}
-}
-
-static void printchar(wchar_t c, unsigned int col, unsigned int row)
+			((short *) scr_addr)[i] = ((style << 8 ) + ' ');
+	}
+}
+
+static void printchar(wchar_t c, sysarg_t col, sysarg_t row)
 {
 	scr_addr[(row * scr_width + col) * 2] = ega_glyph(c);
@@ -158,21 +203,23 @@
  * @param vport Viewport id
  * @param data  Text data.
- * @param x	Leftmost column of the area.
- * @param y	Topmost row of the area.
- * @param w	Number of rows.
- * @param h	Number of columns.
+ * @param x     Leftmost column of the area.
+ * @param y     Topmost row of the area.
+ * @param w     Number of rows.
+ * @param h     Number of columns.
+ *
  */
-static void draw_text_data(keyfield_t *data, unsigned int x,
-    unsigned int y, unsigned int w, unsigned int h)
-{
-	unsigned int i, j;
+static void draw_text_data(keyfield_t *data, sysarg_t x, sysarg_t y,
+    sysarg_t w, sysarg_t h)
+{
+	sysarg_t i;
+	sysarg_t j;
 	keyfield_t *field;
 	uint8_t *dp;
-
+	
 	for (j = 0; j < h; j++) {
 		for (i = 0; i < w; i++) {
 			field = &data[j * w + i];
 			dp = &scr_addr[2 * ((y + j) * scr_width + (x + i))];
-
+			
 			dp[0] = ega_glyph(field->character);
 			dp[1] = attr_to_ega_style(&field->attrs);
@@ -183,111 +230,74 @@
 static int save_screen(void)
 {
-	int i;
-
-	for (i = 0; (i < MAX_SAVED_SCREENS) && (saved_screens[i].data); i++)
-		;
-	if (i == MAX_SAVED_SCREENS) 
+	ipcarg_t i;
+	
+	/* Find empty screen */
+	for (i = 0; (i < MAX_SAVED_SCREENS) && (saved_screens[i].data); i++);
+	
+	if (i == MAX_SAVED_SCREENS)
 		return EINVAL;
-	if (!(saved_screens[i].data = malloc(2 * scr_width * scr_height))) 
+	
+	if (!(saved_screens[i].data = malloc(2 * scr_width * scr_height)))
 		return ENOMEM;
+	
 	memcpy(saved_screens[i].data, scr_addr, 2 * scr_width * scr_height);
-
-	return i;
-}
-
-static int print_screen(int i)
-{
-	if (saved_screens[i].data)
+	return (int) i;
+}
+
+static int print_screen(ipcarg_t i)
+{
+	if ((i >= MAX_SAVED_SCREENS) || (saved_screens[i].data))
 		memcpy(scr_addr, saved_screens[i].data, 2 * scr_width *
 		    scr_height);
 	else
 		return EINVAL;
-	return i;
-}
-
-static int style_to_ega_style(int style)
-{
-	unsigned int ega_style;
-
-	switch (style) {
-	case STYLE_NORMAL:
-		ega_style = INVERTED_COLOR;
-		break;
-	case STYLE_EMPHASIS:
-		ega_style = INVERTED_COLOR | 4;
-		break;
-	default:
-		return INVERTED_COLOR;
-	}
-
-	return ega_style;
-}
-
-static unsigned int color_to_ega_style(int fg_color, int bg_color, int attr)
-{
-	unsigned int style;
-
-	style = (fg_color & 7) | ((bg_color & 7) << 4);
-	if (attr & CATTR_BRIGHT)
-		style = style | 0x08;
-
-	return style;
-}
-
-static unsigned int rgb_to_ega_style(uint32_t fg, uint32_t bg)
-{
-	return (fg > bg) ? NORMAL_COLOR : INVERTED_COLOR;
-}
-
-static unsigned attr_to_ega_style(const attrs_t *a)
-{
-	switch (a->t) {
-	case at_style:
-		return style_to_ega_style(a->a.s.style);
-	case at_rgb:
-		return rgb_to_ega_style(a->a.r.fg_color, a->a.r.bg_color);
-	case at_idx:
-		return color_to_ega_style(a->a.i.fg_color,
-		    a->a.i.bg_color, a->a.i.flags);
-	default:
-		return INVERTED_COLOR;
-	}
-}
-
-static uint8_t ega_glyph(wchar_t ch)
-{
-	if (ch >= 0 && ch < 128)
-		return ch;
-
-	return '?';
+	
+	return (int) i;
 }
 
 static void ega_client_connection(ipc_callid_t iid, ipc_call_t *icall)
 {
-	int retval;
-	ipc_callid_t callid;
-	ipc_call_t call;
-	wchar_t c;
-	unsigned int row, col, w, h;
-	int bg_color, fg_color, attr;
-	uint32_t bg_rgb, fg_rgb;
+	size_t intersize = 0;
 	keyfield_t *interbuf = NULL;
-	size_t intersize = 0;
-	int i;
-
+	
 	if (client_connected) {
 		ipc_answer_0(iid, ELIMIT);
 		return;
 	}
+	
+	/* Accept connection */
 	client_connected = 1;
-	ipc_answer_0(iid, EOK); /* Accept connection */
-
-	while (1) {
-		callid = async_get_call(&call);
- 		switch (IPC_GET_METHOD(call)) {
+	ipc_answer_0(iid, EOK);
+	
+	while (true) {
+		ipc_call_t call;
+		ipc_callid_t callid = async_get_call(&call);
+		
+		wchar_t c;
+		
+		ipcarg_t col;
+		ipcarg_t row;
+		ipcarg_t w;
+		ipcarg_t h;
+		
+		ssize_t rows;
+		
+		uint8_t bg_color;
+		uint8_t fg_color;
+		uint8_t attr;
+		
+		uint32_t fg_rgb;
+		uint32_t bg_rgb;
+		
+		ipcarg_t scr;
+		int retval;
+		
+		switch (IPC_GET_METHOD(call)) {
 		case IPC_M_PHONE_HUNGUP:
 			client_connected = 0;
 			ipc_answer_0(callid, EOK);
-			return; /* Exit thread */
+			
+			/* Exit thread */
+			return;
 		case IPC_M_SHARE_OUT:
 			/* We accept one area for data interchange */
@@ -299,19 +309,23 @@
 				continue;
 			}
+			
 			retval = EINVAL;
 			break;
 		case FB_DRAW_TEXT_DATA:
+			if (!interbuf) {
+				retval = EINVAL;
+				break;
+			}
+			
 			col = IPC_GET_ARG1(call);
 			row = IPC_GET_ARG2(call);
 			w = IPC_GET_ARG3(call);
 			h = IPC_GET_ARG4(call);
-			if (!interbuf) {
+			
+			if ((col + w > scr_width) || (row + h > scr_height)) {
 				retval = EINVAL;
 				break;
 			}
-			if (col + w > scr_width || row + h > scr_height) {
-				retval = EINVAL;
-				break;
-			}
+			
 			draw_text_data(interbuf, col, row, w, h);
 			retval = 0;
@@ -331,28 +345,41 @@
 			col = IPC_GET_ARG2(call);
 			row = IPC_GET_ARG3(call);
-			if (col >= scr_width || row >= scr_height) {
+			
+			if ((col >= scr_width) || (row >= scr_height)) {
 				retval = EINVAL;
 				break;
 			}
+			
 			printchar(c, col, row);
 			retval = 0;
 			break;
- 		case FB_CURSOR_GOTO:
- 			col = IPC_GET_ARG1(call);
+		case FB_CURSOR_GOTO:
+			col = IPC_GET_ARG1(call);
 			row = IPC_GET_ARG2(call);
-			if (row >= scr_height || col >= scr_width) {
+			
+			if ((row >= scr_height) || (col >= scr_width)) {
 				retval = EINVAL;
 				break;
 			}
+			
 			cursor_goto(col, row);
- 			retval = 0;
- 			break;
+			retval = 0;
+			break;
 		case FB_SCROLL:
-			i = IPC_GET_ARG1(call);
-			if (i > (int) scr_height || i < -((int) scr_height)) {
-				retval = EINVAL;
-				break;
-			}
-			scroll(i);
+			rows = IPC_GET_ARG1(call);
+			
+			if (rows >= 0) {
+				if ((ipcarg_t) rows > scr_height) {
+					retval = EINVAL;
+					break;
+				}
+			} else {
+				if ((ipcarg_t) (-rows) > scr_height) {
+					retval = EINVAL;
+					break;
+				}
+			}
+			
+			scroll(rows);
 			retval = 0;
 			break;
@@ -362,4 +389,5 @@
 			else
 				cursor_disable();
+			
 			retval = 0;
 			break;
@@ -372,4 +400,5 @@
 			bg_color = IPC_GET_ARG2(call);
 			attr = IPC_GET_ARG3(call);
+			
 			style = color_to_ega_style(fg_color, bg_color, attr);
 			retval = 0;
@@ -378,10 +407,11 @@
 			fg_rgb = IPC_GET_ARG1(call);
 			bg_rgb = IPC_GET_ARG2(call);
+			
 			style = rgb_to_ega_style(fg_rgb, bg_rgb);
 			retval = 0;
 			break;
 		case FB_VP_DRAW_PIXMAP:
-			i = IPC_GET_ARG2(call);
-			retval = print_screen(i);
+			scr = IPC_GET_ARG2(call);
+			retval = print_screen(scr);
 			break;
 		case FB_VP2PIXMAP:
@@ -389,13 +419,16 @@
 			break;
 		case FB_DROP_PIXMAP:
-			i = IPC_GET_ARG1(call);
-			if (i >= MAX_SAVED_SCREENS) {
+			scr = IPC_GET_ARG1(call);
+			
+			if (scr >= MAX_SAVED_SCREENS) {
 				retval = EINVAL;
 				break;
 			}
-			if (saved_screens[i].data) {
-				free(saved_screens[i].data);
-				saved_screens[i].data = NULL;
-			}
+			
+			if (saved_screens[scr].data) {
+				free(saved_screens[scr].data);
+				saved_screens[scr].data = NULL;
+			}
+			
 			retval = 0;
 			break;
@@ -413,32 +446,39 @@
 int ega_init(void)
 {
-	void *ega_ph_addr;
-	size_t sz;
-
-	ega_ph_addr = (void *) sysinfo_value("fb.address.physical");
-	scr_width = sysinfo_value("fb.width");
-	scr_height = sysinfo_value("fb.height");
-
-	if (sysinfo_value("fb.blinking")) {
-		ega_normal_color &= 0x77;
-		ega_inverted_color &= 0x77;
-	}
-
-	style = NORMAL_COLOR;
-
+	sysarg_t paddr;
+	if (sysinfo_get_value("fb.address.physical", &paddr) != EOK)
+		return -1;
+	
+	if (sysinfo_get_value("fb.width", &scr_width) != EOK)
+		return -1;
+	
+	if (sysinfo_get_value("fb.height", &scr_height) != EOK)
+		return -1;
+	
+	sysarg_t blinking;
+	if (sysinfo_get_value("fb.blinking", &blinking) != EOK)
+		blinking = false;
+	
+	void *ega_ph_addr = (void *) paddr;
+	if (blinking) {
+		style_normal &= 0x77;
+		style_inverted &= 0x77;
+	}
+	
+	style = style_normal;
+	
 	iospace_enable(task_get_id(), (void *) EGA_IO_BASE, 2);
-
-	sz = scr_width * scr_height * 2;
+	
+	size_t sz = scr_width * scr_height * 2;
 	scr_addr = as_get_mappable_page(sz);
-
+	
 	if (physmem_map(ega_ph_addr, scr_addr, ALIGN_UP(sz, PAGE_SIZE) >>
 	    PAGE_WIDTH, AS_AREA_READ | AS_AREA_WRITE) != 0)
 		return -1;
-
+	
 	async_set_client_connection(ega_client_connection);
-
+	
 	return 0;
 }
-
 
 /**
